package com.tzy.common.core.domain;

import java.util.HashMap;

import com.tzy.common.utils.StringUtils;

/**
 * 操作消息提醒
 * 
 * @author zheng
 */
public class MsgResult extends HashMap<String, Object>
{
    private static final long serialVersionUID = 1L;

    /** 状态码 */
    public static final String TYPE_TAG = "type";

    /** 返回内容 */
    public static final String MSG_TAG = "message";

    /** 数据对象 */
    public static final String DATA_TAG = "data";

    /**
     * 状态类型
     */
    public enum Type
    {
        /** 成功 */
        SUCCESS(1),
        /** 警告 */
        WARN(3),
        /** 错误 */
        ERROR(3);
        private final int value;

        Type(int value)
        {
            this.value = value;
        }

        public int value()
        {
            return this.value;
        }
    }

    /**
     * 初始化一个新创建的 MsgResult 对象，使其表示一个空消息。
     */
    public MsgResult()
    {
    }

    /**
     * 初始化一个新创建的 MsgResult 对象
     * 
     * @param type 状态类型
     * @param msg 返回内容
     */
    public MsgResult(Type type, String msg)
    {
        super.put(TYPE_TAG, type.value);
        super.put(MSG_TAG, msg);
    }

    /**
     * 初始化一个新创建的 MsgResult 对象
     * 
     * @param type 状态类型
     * @param msg 返回内容
     * @param data 数据对象
     */
    public MsgResult(Type type, String msg, Object data)
    {
        super.put(TYPE_TAG, type.value);
        super.put(MSG_TAG, msg);
        if (StringUtils.isNotNull(data))
        {
            super.put(DATA_TAG, data);
        }
    }

    /**
     * 返回成功消息
     * 
     * @return 成功消息
     */
    public static MsgResult success()
    {
        return MsgResult.success("操作成功");
    }

    /**
     * 返回成功数据
     * 
     * @return 成功消息
     */
    public static MsgResult success(Object data)
    {
        return MsgResult.success("操作成功", data);
    }

    /**
     * 返回成功消息
     * 
     * @param msg 返回内容
     * @return 成功消息
     */
    public static MsgResult success(String msg)
    {
        return MsgResult.success(msg, null);
    }

    /**
     * 方便链式调用
     *
     * @param key 键
     * @param value 值
     * @return 数据对象
     */
    @Override
    public MsgResult put(String key, Object value)
    {
        super.put(key, value);
        return this;
    }

    /**
     * 返回成功消息
     * 
     * @param msg 返回内容
     * @param data 数据对象
     * @return 成功消息
     */
    public static MsgResult success(String msg, Object data)
    {
        return new MsgResult(Type.SUCCESS, msg, data);
    }

    /**
     * 返回警告消息
     * 
     * @param msg 返回内容
     * @return 警告消息
     */
    public static MsgResult warn(String msg)
    {
        return MsgResult.warn(msg, null);
    }

    /**
     * 返回警告消息
     * 
     * @param msg 返回内容
     * @param data 数据对象
     * @return 警告消息
     */
    public static MsgResult warn(String msg, Object data)
    {
        return new MsgResult(Type.WARN, msg, data);
    }

    /**
     * 返回错误消息
     * 
     * @return
     */
    public static MsgResult error()
    {
        return MsgResult.error("操作失败");
    }

    /**
     * 返回错误消息
     * 
     * @param msg 返回内容
     * @return 警告消息
     */
    public static MsgResult error(String msg)
    {
        return MsgResult.error(msg, null);
    }

    /**
     * 返回错误消息
     * 
     * @param msg 返回内容
     * @param data 数据对象
     * @return 警告消息
     */
    public static MsgResult error(String msg, Object data)
    {
        return new MsgResult(Type.ERROR, msg, data);
    }
}
